---
- name: Set Automation Controller job template name
  ansible.builtin.set_fact:
    aapctl_job_template: "{{ aap_controller_job_template }}"

- name: Create Ansible Automation Controller job
  kubernetes.core.k8s:
    definition:
      apiVersion: tower.ansible.com/v1alpha1
      metadata:
        name: "{{ aapctl_instance_name }}-job"
        namespace: "{{ aap_operator_namespace }}"
      kind: AnsibleJob
      spec:
        job_template_name: "{{ aapctl_job_template }}"
        tower_auth_secret: "{{ aapctl_instance_name }}-auth-secret"
    state: present

- name: Wait till Automation Controller job finishes 
  kubernetes.core.k8s_info:
    api_version: tower.ansible.com/v1alpha1
    kind: AnsibleJob
    name: "{{ aapctl_instance_name }}-job"
    namespace: "{{ aap_operator_namespace }}"
  register: aapctl_job_obj
  until:
    - aapctl_job_obj.resources[0].status.ansibleJobResult is defined
    - aapctl_job_obj.resources[0].status.ansibleJobResult.status == "successful"
  retries: 75
  delay: 10

- name: Get Automation Controller job url
  ansible.builtin.set_fact:
    aapctl_job_url: "{{ aapctl_job_obj | json_query('resources[*].status.ansibleJobResult.url') }}"

- name: Print Automation Controller job url
  ansible.builtin.debug:
    msg:
    - "Automation Controller Job URL: https://{{ aapctl_job_url[0] }}"
